package sav.example.javaz;
import sav.z.*;
import java.io.*;
/**
 * This is example of the Commutator using.
 * The example stops printing that a few Sessions do simultaneously.
 * Also, illustration of the Session's setReportPrinter() method may be very useful.
 */
class CommutatorDemo implements Runnable {
  public static void main(String arg[]) throws Exception {
    Session ss0 = new Session();
    ss0.modifyBase("Data");
    ss0.z("$base ~");
    for (int i = 0; i < 10; ++i) {
      ss0.z("Data:#");
    }
    ss0.close();
    String text =
      "= $base Data;\n" +
      "$p(Data:);\n"
    ;
    /***********************/
    Commutator comm = new Commutator();
    for (int i = 1; i <= 50; ++i) {
      Session ss = new Session();
      MyPrinter prt = new MyPrinter("Session " + i + ": ");
      ss.setReportPrinter(prt);
      ss.setCommutator(comm);
      CommutatorDemo cd = new CommutatorDemo(ss, text);
      new Thread(cd).start();
    }
    Thread.sleep(400);
    comm.setOff(true);
    /***********************/
  }

  Session ss;
  String text;
  CommutatorDemo(Session ss, String text) throws IOException {
    this.ss = ss;
    this.text = text;
  }
  public void run() {
    ss.z(text);
  }
}

class MyPrinter extends ConsolePrinter {
  String info;
  MyPrinter(String info) {
    super();
    this.info = info;
  }
  public void println(String s) {
    super.println(info + s);
  }
}

